View Issue Details

IDProjectCategoryView StatusLast Update
0001938OpenFOAM[All Projects] Bugpublic2016-04-25 16:40
Reporteruser4Assigned Tohenry 
PrioritynormalSeverityminorReproducibilityalways
Status resolvedResolutionfixed 
PlatformGNU/LinuxOSOpenSuSEOS Version12.3
Product Versiondev 
Fixed in Versiondev 
Summary0001938: upToDate checking not synchronised in parallell
Description- cacheing of grad(U) uses eventNo
- eventNo not synchronised in parallel
- so if overflow one processor might trigger update
- not synchronised -> crash
Steps To ReproduceRun attached code on e.g. pitzDaily on two processors.
TagsNo tags attached.

Activities

user4

2015-12-02 14:17

 

simpleFoam.C (2,933 bytes)

henry

2016-04-20 21:06

manager   ~0006145

Can you provide a patch to correct this problem? I have not seen the issue arise on any cases I have run.

MattijsJ

2016-04-21 20:17

reporter   ~0006152

Last edited: 2016-04-21 20:21

View 2 revisions

Bit more info
- The problem only comes up after running huge number of iterations.
- the upToDate checking (event counter) is local only and cannot be parallel consistent
- the issue comes up if the event counter overruns and starts from zero and this gets flagged as out-of-date. This still is not a problem (just some additional evaluation) but it might be a problem in parallel if another processor does not yet overflow.
- solutions:
1) handle event counter overflow
2) go through code and avoid excessive event number generation (better).

henry

2016-04-21 20:28

manager   ~0006153

Do you have a patch for either solution?

MattijsJ

2016-04-22 11:29

reporter  

forAllBoundaryField.sed (154 bytes)

henry

2016-04-25 16:40

manager   ~0006172

Resolved by commit a4e2afa4b39e2f33f7b66051844cccf0296be520

Issue History

Date Modified Username Field Change
2015-12-02 14:17 user4 New Issue
2015-12-02 14:17 user4 File Added: simpleFoam.C
2016-04-20 21:06 henry Note Added: 0006145
2016-04-21 20:17 MattijsJ Note Added: 0006152
2016-04-21 20:21 MattijsJ Note Edited: 0006152 View Revisions
2016-04-21 20:28 henry Note Added: 0006153
2016-04-22 11:29 MattijsJ File Added: forAllBoundaryField.sed
2016-04-25 16:40 henry Note Added: 0006172
2016-04-25 16:40 henry Status new => resolved
2016-04-25 16:40 henry Fixed in Version => dev
2016-04-25 16:40 henry Resolution open => fixed
2016-04-25 16:40 henry Assigned To => henry